"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
exports.RevealOperation = void 0;
var operation_errors_1 = require("./operation-errors");
var operations_1 = require("./operations");
/**
 * @description Reveal operation provides utility functions to fetch a newly issued revelation
 */
var RevealOperation = /** @class */ (function (_super) {
    __extends(RevealOperation, _super);
    function RevealOperation(hash, params, source, raw, results, context) {
        var _this = _super.call(this, hash, raw, results, context) || this;
        _this.params = params;
        _this.source = source;
        return _this;
    }
    Object.defineProperty(RevealOperation.prototype, "operationResults", {
        get: function () {
            var revealOp = Array.isArray(this.results) &&
                this.results.find(function (op) { return op.kind === 'reveal'; });
            return revealOp ? [revealOp] : [];
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RevealOperation.prototype, "status", {
        get: function () {
            var operationResults = this.operationResults;
            var txResult = operationResults[0];
            if (txResult) {
                return txResult.metadata.operation_result.status;
            }
            else {
                return 'unknown';
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RevealOperation.prototype, "fee", {
        get: function () {
            return this.params.fee;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RevealOperation.prototype, "gasLimit", {
        get: function () {
            return this.params.gas_limit;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RevealOperation.prototype, "storageLimit", {
        get: function () {
            return this.params.storage_limit;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RevealOperation.prototype, "publicKey", {
        get: function () {
            return this.params.public_key;
        },
        enumerable: false,
        configurable: true
    });
    RevealOperation.prototype.sumProp = function (arr, prop) {
        return arr.reduce(function (prev, current) {
            return prop in current ? Number(current[prop]) + prev : prev;
        }, 0);
    };
    Object.defineProperty(RevealOperation.prototype, "consumedGas", {
        get: function () {
            return String(this.sumProp(operation_errors_1.flattenOperationResult({ contents: this.operationResults }), 'consumed_gas'));
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RevealOperation.prototype, "storageDiff", {
        get: function () {
            return String(this.sumProp(operation_errors_1.flattenOperationResult({ contents: this.operationResults }), 'paid_storage_size_diff'));
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RevealOperation.prototype, "storageSize", {
        get: function () {
            return String(this.sumProp(operation_errors_1.flattenOperationResult({ contents: this.operationResults }), 'storage_size'));
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RevealOperation.prototype, "errors", {
        get: function () {
            return operation_errors_1.flattenErrors({ contents: this.operationResults });
        },
        enumerable: false,
        configurable: true
    });
    return RevealOperation;
}(operations_1.Operation));
exports.RevealOperation = RevealOperation;
//# sourceMappingURL=reveal-operation.js.map